<?php
/*
Plugin Name: WP-Polls-Plus
Plugin URI: http://www.customsoft.it/
Description: Adds option to WP-Poll plugin for authorized single user to vote.
Version: 0.01
Author: Zordan Marco - Customsoft di Zordan Marco
Author URI: http://www.customsoft.it/
*/


/*
	Copyright 2009  Lester Chan  (email : lesterchan@gmail.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

if ( !defined( 'TIMER' ) ){ define ("TIMER", GetMicroTime());}

if ( !defined( 'WP_CONTENT_URL' ) ){ define( 'WP_CONTENT_URL', get_option( 'siteurl' ).'/wp-content' ); }
if ( !defined( 'WP_CONTENT_DIR' ) ){ define( 'WP_CONTENT_DIR', ABSPATH.'wp-content' ); }
if ( !defined( 'WP_PLUGIN_URL' ) ){ define( 'WP_PLUGIN_URL', WP_CONTENT_URL. '/plugins' ); }
if ( !defined( 'WP_PLUGIN_DIR' ) ){ define( 'WP_PLUGIN_DIR', WP_CONTENT_DIR.'/plugins' ); }

if ( !defined( 'WP_PP_DIR' ) ){ define( 'WP_PP_DIR', WP_PLUGIN_DIR.'/wp-polls-plus' ); }
if ( !defined( 'WP_PP_LOG' ) ){ define( 'WP_PP_LOG', WP_PP_DIR.'/error.log' ); }

### Load WP-Config File If This File Is Called Directly
if (!function_exists('add_action')) {
	$wp_root = '../../..';
	if (file_exists($wp_root.'/wp-load.php')) {
		require_once($wp_root.'/wp-load.php');
	} else {
		require_once($wp_root.'/wp-config.php');
	}
} # if (!function_exists('add_action')) {


### Function: Short Code For Inserting Polls Into Posts
add_shortcode('pollplus', 'poll_plus_shortcode');
function poll_plus_shortcode($atts) {
  #logga ( '11'.json_encode($atts), WP_PP_LOG);

  extract(shortcode_atts(array('id' => 0, 'type' => 'vote'), $atts));

	### Check Whether User Can VOTE Polls
  if(current_user_can('vote_polls')) {

  	if(!is_feed()) {

  		if($type == 'vote') {
        #logga ( '22'.json_encode($atts), WP_PP_LOG);
  			return get_poll($id, false);
  		} elseif($type == 'result') {
        logga ( '33'.json_encode($atts), WP_PP_LOG);
  			return display_pollresult($id);
  		} # if($type == 'vote')

  	} else {
  		return __('Note: There is a poll embedded within this post, please visit the site to participate in this post\'s poll.', 'wp-polls');
  	} # if(!is_feed())

  } else {
    #logga ( '44'.json_encode($atts), WP_PP_LOG);
		return display_pollresult($id,array('1'));
  } # if(!current_user_can('vote_polls'))

} # poll_plus_shortcode($atts)

### Function: Hack Profile For Inserting Checkbox Into User panel
add_action( 'show_user_profile', 'poll_plus_hack_profile' );
add_action( 'edit_user_profile', 'poll_plus_hack_profile' );
function poll_plus_hack_profile() {
  if ( current_user_can('edit_users') ) {
    $aProfile = poll_plus_get_profile();
    if ( $aProfile == null ) {
      $aProfile = array( "chkVotante"=>'' );
    } # if ( $aProfile == null )

    echo '<h3>'.__('Profilo Poll Plus').'</h3>
      <table class="form-table">';

    foreach($aProfile as $key => $value) {
      if ( 'chk'===substr($key,0,3) ) {
        echo '
          <tr>
            <th><label for="'.$key.'">'.str_replace( 'chk', '', $key ).'</label></th>
            <td><input type="checkbox" name="'.$key.'" id="'.$key.'"'.($value=='on'?' checked="checked"':'').' /></td>
          </tr>
        ';
      } elseif('txt'===substr($key,0,3)){
        echo '
          <tr>
            <th><label for="'.$key.'">'.str_replace( 'txt', '', $key ).'</label></th>
            <td><input type="text" name="'.$key.'" id="'.$key.'" value="'.$value.'" /></td>
          </tr>
        ';
      }
    } # foreach($aProfile as $key => $value)
    echo '</table>';
  } # if ( current_user_can('edit_users') )
} # poll_plus_hack_profile()

# Hack per salvare il metadata in Usermeta ( Called in wp-admin/users.php and wp-admin/profile.php )
add_action( 'profile_update',    'poll_plus_hack_save_profile' );
function poll_plus_hack_save_profile() {
  global $user_ID;
  if ( current_user_can('edit_users') ) {
    $nId=0;
    $aProfile = array();

    if (preg_match('%profile.php%', $_SERVER['REQUEST_URI'])) {
      $nId = (int)$user_ID;
    } elseif($_POST['user_id']) {
      $nId = (int)$_POST['user_id'];
    } # if (preg_match('%profile.php%', $_SERVER['REQUEST_URI'])) {
    
    if ($nId>0) {
      $objUser = new WP_User($nId);
      $objUser->remove_cap('vote_polls');
      foreach($_POST as $key => $value) {
        if (preg_match('%chkVotante%', $key) && $value) {
          $objUser->add_cap('vote_polls', true);
          $aProfile[$key] = $value;
        }
      } # foreach($_POST as $key => $value)

      #      logga (json_encode($aProfile), WP_PP_LOG);

      update_usermeta($nId, 'poll_plus_profile', $aProfile);
    } # if ($nId>0)
    
  } # if ( current_user_can('edit_users') )

} # poll_plus_hack_save_profile()

function poll_plus_get_profile() {
  global $user_ID;

  if (preg_match('%profile.php%', $_SERVER['REQUEST_URI'])) {
    $nId = (int)$user_ID;
  } elseif($_GET['user_id']) {
    $nId = (int)$_GET['user_id'];
  } # if (preg_match('%profile.php%', $_SERVER['REQUEST_URI']))

  $aProfile = get_usermeta( $nId, 'poll_plus_profile', TRUE );
  return $aProfile;
} # poll_plus_get_profile()

# Create capacity 'vote_polls' in base role 
register_activation_hook( __FILE__, 'poll_plus_create_role' );
function poll_plus_create_role() {
  $aRoles = array();
  $aRoles['administrator'] = '';
  $aRoles['editor'] = '';
  $aRoles['author'] = '';
  $aRoles['contributor'] = '';
  $aRoles['subscriber'] = '';

  $aCap = array();
  $aCap[] = 'vote_polls';

  foreach ($aRoles as $sRoleKey=>$sRoleValue) {
  	$objRole = get_role($sRoleKey);
    foreach ($aCap as $sCapKey=>$sCapValue) {
      $objRole->add_cap($sCapValue, false);
    } # foreach ($aCap as $sCapKey=>$sCapValue)
  } # foreach ($aRoles as $sRoleKey=>$sRoleValue) {
} # poll_plus_create_role()



########################
# function LOG
# Save in file log the string.
function Logga($sString, $sFileName='') {
  if ( $sFileName !== '' ) {
    error_log("- ".DATE("d.m.Y H:i:s").': '.number_format(GetMicroTime()-TIMER,4).
      ' sec. - '.$sString."\n", 3, $sFileName);
  } else {
    error_log(" - ".number_format(GetMicroTime()-TIMER,4).' sec. - '.$sString."\n", 0);
  } # if ( $sFileName !=== '' ) {
} # function Logga($sString, $sFileName='')

########################
# function TIMER
# Return microsecond
function GetMicroTime(){
   list($usec, $sec) = explode(" ",microtime());
   return ((float)$usec + (float)$sec);
} # function GetMicroTime()



?>
